searchNodes=[{"doc":"","ref":"ExAws.Operation.S3DeleteAllObjects.html","title":"ExAws.Operation.S3DeleteAllObjects","type":"module"},{"doc":"","ref":"ExAws.Operation.S3DeleteAllObjects.html#t:t/0","title":"ExAws.Operation.S3DeleteAllObjects.t/0","type":"type"},{"doc":"Service module for https://github.com/ex-aws/ex_aws Installation The package can be installed by adding :ex_aws_s3 to your list of dependencies in mix.exs along with :ex_aws , your preferred JSON codec / HTTP client, and optionally :sweet_xml to support operations like list_objects that require XML parsing. def deps do [ { :ex_aws , &quot;~&gt; 2.0&quot; } , { :ex_aws_s3 , &quot;~&gt; 2.0&quot; } , { :poison , &quot;~&gt; 3.0&quot; } , { :hackney , &quot;~&gt; 1.9&quot; } , { :sweet_xml , &quot;~&gt; 0.6.6&quot; } , # optional dependency ] end Operations on AWS S3 Basic Operations The vast majority of operations here represent a single operation on S3. Examples S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . request! #=&gt; %{body: [list, of, objects]} S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . stream! |&gt; Enum . to_list #=&gt; [list, of, objects] S3 . put_object ( &quot;my-bucket&quot; , &quot;path/to/bucket&quot; , contents ) |&gt; ExAws . request! Higher Level Operations There are also some operations which operate at a higher level to make it easier to download and upload very large files. Multipart uploads &quot;path/to/big/file&quot; |&gt; S3.Upload . stream_file |&gt; S3 . upload ( &quot;my-bucket&quot; , &quot;path/on/s3&quot; ) |&gt; ExAws . request #=&gt; {:ok, :done} See ExAws.S3.upload/4 for options Download large file to disk S3 . download_file ( &quot;my-bucket&quot; , &quot;path/on/s3&quot; , &quot;path/to/dest/file&quot; ) |&gt; ExAws . request #=&gt; {:ok, :done} More high level functionality Task.async_stream makes some high level flows so easy you don't need explicit ExAws support. For example, here is how to concurrently upload many files. upload_file = fn { src_path , dest_path } -&gt; S3 . put_object ( &quot;my_bucket&quot; , dest_path , File . read! ( src_path ) ) |&gt; ExAws . request! end paths = %{ &quot;path/to/src0&quot; =&gt; &quot;path/to/dest0&quot; , &quot;path/to/src1&quot; =&gt; &quot;path/to/dest1&quot; } paths |&gt; Task . async_stream ( upload_file , max_concurrency : 10 ) |&gt; Stream . run Bucket as host functionality Examples opts = [ virtual_host : true , bucket_as_host : true ] ExAws.Config . new ( :s3 ) |&gt; S3 . presigned_url ( :get , &quot;bucket.custom-domain.com&quot; , &quot;foo.txt&quot; , opts ) { :ok , &quot;https://bucket.custom-domain.com/foo.txt&quot; } Configuration The scheme , host , and port can be configured to hit alternate endpoints. For example, this is how to use a local minio instance: # config.exs config :ex_aws , :s3 , scheme : &quot;http://&quot; , host : &quot;localhost&quot; , port : 9000","ref":"ExAws.S3.html","title":"ExAws.S3","type":"module"},{"doc":"Abort a multipart upload","ref":"ExAws.S3.html#abort_multipart_upload/3","title":"ExAws.S3.abort_multipart_upload/3","type":"function"},{"doc":"Complete a multipart upload","ref":"ExAws.S3.html#complete_multipart_upload/4","title":"ExAws.S3.complete_multipart_upload/4","type":"function"},{"doc":"Delete all listed objects. When performed, this function will continue making delete_multiple_objects requests deleting 1000 objects at a time until all are deleted. Can be streamed. Example stream = ExAws.S3 . list_objects ( bucket ( ) , prefix : &quot;some/prefix&quot; ) |&gt; ExAws . stream! ( ) |&gt; Stream . map ( &amp; &amp;1 . key ) ExAws.S3 . delete_all_objects ( bucket ( ) , stream ) |&gt; ExAws . request ( )","ref":"ExAws.S3.html#delete_all_objects/3","title":"ExAws.S3.delete_all_objects/3","type":"function"},{"doc":"Delete a bucket","ref":"ExAws.S3.html#delete_bucket/1","title":"ExAws.S3.delete_bucket/1","type":"function"},{"doc":"Delete a bucket cors","ref":"ExAws.S3.html#delete_bucket_cors/1","title":"ExAws.S3.delete_bucket_cors/1","type":"function"},{"doc":"Delete a bucket lifecycle","ref":"ExAws.S3.html#delete_bucket_lifecycle/1","title":"ExAws.S3.delete_bucket_lifecycle/1","type":"function"},{"doc":"Delete a bucket policy","ref":"ExAws.S3.html#delete_bucket_policy/1","title":"ExAws.S3.delete_bucket_policy/1","type":"function"},{"doc":"Delete a bucket replication","ref":"ExAws.S3.html#delete_bucket_replication/1","title":"ExAws.S3.delete_bucket_replication/1","type":"function"},{"doc":"Delete a bucket tagging","ref":"ExAws.S3.html#delete_bucket_tagging/1","title":"ExAws.S3.delete_bucket_tagging/1","type":"function"},{"doc":"Delete a bucket website","ref":"ExAws.S3.html#delete_bucket_website/1","title":"ExAws.S3.delete_bucket_website/1","type":"function"},{"doc":"Delete multiple objects within a bucket Limited to 1000 objects.","ref":"ExAws.S3.html#delete_multiple_objects/3","title":"ExAws.S3.delete_multiple_objects/3","type":"function"},{"doc":"Delete an object within a bucket","ref":"ExAws.S3.html#delete_object/3","title":"ExAws.S3.delete_object/3","type":"function"},{"doc":"Remove the entire tag set from the specified object","ref":"ExAws.S3.html#delete_object_tagging/3","title":"ExAws.S3.delete_object_tagging/3","type":"function"},{"doc":"Download an S3 object to a file. This operation downloads multiple parts of an S3 object concurrently, allowing you to maximize throughput. Defaults to a concurrency of 8, chunk size of 1MB, and a timeout of 1 minute. Streaming to memory In order to use ExAws.stream!/2 , the third dest parameter must be set to :memory . An example would be like the following: ExAws.S3 . download_file ( &quot;example-bucket&quot; , &quot;path/to/file.txt&quot; , :memory ) |&gt; ExAws . stream! ( ) Note that this won't start fetching anything immediately since it returns an Elixir Stream . Streaming by line Streaming by line can be done with Stream.chunk_while/4 . Here is an example: # Returns a stream which grabs chunks of data from S3 as specified in `opts` # but processes the stream line by line. For example, the default chunk # size of 1MB means requests for bytes from S3 will ask for 1MB sizes (to be downloaded) # however each element of the stream will be a single line. def generate_stream ( bucket , file , opts \\\\ \\\\ [ ] ) do bucket |&gt; ExAws.S3 . download_file ( file , :memory , opts ) |&gt; ExAws . stream! ( ) # Uncomment if you need to gunzip (and add dependency :stream_gzip) # |&gt; StreamGzip.gunzip() |&gt; Stream . chunk_while ( &quot;&quot; , &amp; chunk_fun / 2 , &amp; to_line_stream_after_fun / 1 ) |&gt; Stream . concat ( ) end def chunk_fun ( chunk , acc ) do to_try = acc &lt;&gt; chunk { elements , acc } = chunk_by_newline ( to_try , &quot; \\n &quot; , [ ] , { 0 , byte_size ( to_try ) } ) { :cont , elements , acc } end defp chunk_by_newline ( _string , _newline , elements , { _offset , 0 } ) do { Enum . reverse ( elements ) , &quot;&quot; } end defp chunk_by_newline ( string , newline , elements , { offset , length } ) do case :binary . match ( string , newline , scope : { offset , length } ) do { newline_offset , newline_length } -&gt; difference = newline_length + newline_offset - offset element = binary_part ( string , offset , difference ) chunk_by_newline ( string , newline , [ element | elements ] , { newline_offset + newline_length , length - difference } ) :nomatch -&gt; { Enum . reverse ( elements , binary_part ( string , offset , length ) ) } end end defp to_line_stream_after_fun ( &quot;&quot; ) , do : { :cont , [ ] } defp to_line_stream_after_fun ( acc ) , do : { :cont , [ acc ] , [ ] }","ref":"ExAws.S3.html#download_file/4","title":"ExAws.S3.download_file/4","type":"function"},{"doc":"Get bucket acl","ref":"ExAws.S3.html#get_bucket_acl/1","title":"ExAws.S3.get_bucket_acl/1","type":"function"},{"doc":"Get bucket cors","ref":"ExAws.S3.html#get_bucket_cors/1","title":"ExAws.S3.get_bucket_cors/1","type":"function"},{"doc":"Get bucket lifecycle","ref":"ExAws.S3.html#get_bucket_lifecycle/1","title":"ExAws.S3.get_bucket_lifecycle/1","type":"function"},{"doc":"Get bucket location","ref":"ExAws.S3.html#get_bucket_location/1","title":"ExAws.S3.get_bucket_location/1","type":"function"},{"doc":"Get bucket logging","ref":"ExAws.S3.html#get_bucket_logging/1","title":"ExAws.S3.get_bucket_logging/1","type":"function"},{"doc":"Get bucket notification","ref":"ExAws.S3.html#get_bucket_notification/1","title":"ExAws.S3.get_bucket_notification/1","type":"function"},{"doc":"Get bucket object versions","ref":"ExAws.S3.html#get_bucket_object_versions/2","title":"ExAws.S3.get_bucket_object_versions/2","type":"function"},{"doc":"Get bucket policy","ref":"ExAws.S3.html#get_bucket_policy/1","title":"ExAws.S3.get_bucket_policy/1","type":"function"},{"doc":"Get bucket replication","ref":"ExAws.S3.html#get_bucket_replication/1","title":"ExAws.S3.get_bucket_replication/1","type":"function"},{"doc":"Get bucket payment configuration","ref":"ExAws.S3.html#get_bucket_request_payment/1","title":"ExAws.S3.get_bucket_request_payment/1","type":"function"},{"doc":"Get bucket tagging","ref":"ExAws.S3.html#get_bucket_tagging/1","title":"ExAws.S3.get_bucket_tagging/1","type":"function"},{"doc":"Get bucket versioning","ref":"ExAws.S3.html#get_bucket_versioning/1","title":"ExAws.S3.get_bucket_versioning/1","type":"function"},{"doc":"Get bucket website","ref":"ExAws.S3.html#get_bucket_website/1","title":"ExAws.S3.get_bucket_website/1","type":"function"},{"doc":"Get an object from a bucket Examples S3 . get_object ( &quot;my-bucket&quot; , &quot;image.png&quot; ) S3 . get_object ( &quot;my-bucket&quot; , &quot;image.png&quot; , version_id : &quot;ae57ekgXPpdiVZLkYVWoTAGRhGJ5swt9&quot; )","ref":"ExAws.S3.html#get_object/3","title":"ExAws.S3.get_object/3","type":"function"},{"doc":"Get an object's access control policy","ref":"ExAws.S3.html#get_object_acl/3","title":"ExAws.S3.get_object_acl/3","type":"function"},{"doc":"Get object tagging","ref":"ExAws.S3.html#get_object_tagging/3","title":"ExAws.S3.get_object_tagging/3","type":"function"},{"doc":"Get a torrent for a bucket","ref":"ExAws.S3.html#get_object_torrent/2","title":"ExAws.S3.get_object_torrent/2","type":"function"},{"doc":"Determine if a bucket exists","ref":"ExAws.S3.html#head_bucket/1","title":"ExAws.S3.head_bucket/1","type":"function"},{"doc":"Determine if an object exists","ref":"ExAws.S3.html#head_object/3","title":"ExAws.S3.head_object/3","type":"function"},{"doc":"Initiate a multipart upload","ref":"ExAws.S3.html#initiate_multipart_upload/3","title":"ExAws.S3.initiate_multipart_upload/3","type":"function"},{"doc":"List buckets","ref":"ExAws.S3.html#list_buckets/1","title":"ExAws.S3.list_buckets/1","type":"function"},{"doc":"List multipart uploads for a bucket","ref":"ExAws.S3.html#list_multipart_uploads/2","title":"ExAws.S3.list_multipart_uploads/2","type":"function"},{"doc":"List objects in bucket Can be streamed. Examples S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . request S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . stream! S3 . list_objects ( &quot;my-bucket&quot; , delimiter : &quot;/&quot; , prefix : &quot;backup&quot; ) |&gt; ExAws . stream! S3 . list_objects ( &quot;my-bucket&quot; , prefix : &quot;some/inner/location/path&quot; ) |&gt; ExAws . stream! S3 . list_objects ( &quot;my-bucket&quot; , max_keys : 5 , encoding_type : &quot;url&quot; ) |&gt; ExAws . stream!","ref":"ExAws.S3.html#list_objects/2","title":"ExAws.S3.list_objects/2","type":"function"},{"doc":"List objects in bucket Can be streamed. Examples S3 . list_objects_v2 ( &quot;my-bucket&quot; ) |&gt; ExAws . request S3 . list_objects_v2 ( &quot;my-bucket&quot; ) |&gt; ExAws . stream! S3 . list_objects_v2 ( &quot;my-bucket&quot; , delimiter : &quot;/&quot; , prefix : &quot;backup&quot; ) |&gt; ExAws . stream! S3 . list_objects_v2 ( &quot;my-bucket&quot; , prefix : &quot;some/inner/location/path&quot; ) |&gt; ExAws . stream! S3 . list_objects_v2 ( &quot;my-bucket&quot; , max_keys : 5 , encoding_type : &quot;url&quot; ) |&gt; ExAws . stream!","ref":"ExAws.S3.html#list_objects_v2/2","title":"ExAws.S3.list_objects_v2/2","type":"function"},{"doc":"List the parts of a multipart upload","ref":"ExAws.S3.html#list_parts/4","title":"ExAws.S3.list_parts/4","type":"function"},{"doc":"Determine the CORS configuration for an object","ref":"ExAws.S3.html#options_object/5","title":"ExAws.S3.options_object/5","type":"function"},{"doc":"Restore an object to a particular version","ref":"ExAws.S3.html#post_object_restore/4","title":"ExAws.S3.post_object_restore/4","type":"function"},{"doc":"Generate a pre-signed post for an object. When option param :virtual_host is true , the bucket name will be used in the hostname, along with the s3 default host which will look like - &lt;bucket&gt;.s3.&lt;region&gt;.amazonaws.com host. When option param :s3_accelerate is true , the bucket name will be used as the hostname, along with the s3-accelerate.amazonaws.com host. When option param :bucket_as_host is true , the bucket name will be used as the full hostname. In this case, bucket must be set to a full hostname, for example mybucket.example.com . The bucket_as_host must be passed along with virtual_host=true","ref":"ExAws.S3.html#presigned_post/4","title":"ExAws.S3.presigned_post/4","type":"function"},{"doc":"Generate a pre-signed URL for an object. When option param :virtual_host is true , the bucket name will be used in the hostname, along with the s3 default host which will look like - &lt;bucket&gt;.s3.&lt;region&gt;.amazonaws.com host. When option param :s3_accelerate is true , the bucket name will be used as the hostname, along with the s3-accelerate.amazonaws.com host. When option param :bucket_as_host is true , the bucket name will be used as the full hostname. In this case, bucket must be set to a full hostname, for example mybucket.example.com . The bucket_as_host must be passed along with virtual_host=true Additional (signed) query parameters can be added to the url by setting option param :query_params to a list of {&quot;key&quot;, &quot;value&quot;} pairs. Useful if you are uploading parts of a multipart upload directly from the browser. Signed headers can be added to the url by setting option param :headers to a list of {&quot;key&quot;, &quot;value&quot;} pairs.","ref":"ExAws.S3.html#presigned_url/5","title":"ExAws.S3.presigned_url/5","type":"function"},{"doc":"Creates a bucket in the specified region","ref":"ExAws.S3.html#put_bucket/3","title":"ExAws.S3.put_bucket/3","type":"function"},{"doc":"Update or create a bucket access control policy","ref":"ExAws.S3.html#put_bucket_acl/2","title":"ExAws.S3.put_bucket_acl/2","type":"function"},{"doc":"Update or create a bucket CORS policy","ref":"ExAws.S3.html#put_bucket_cors/2","title":"ExAws.S3.put_bucket_cors/2","type":"function"},{"doc":"Update or create a bucket lifecycle configuration Live-Cycle Rule Format %{ # Unique id for the rule (max. 255 chars, max. 1000 rules allowed) id : &quot;123&quot; , # Disabled rules are not executed enabled : true , # Filters # Can be based on prefix, object tag(s), both or none filter : %{ prefix : &quot;prefix/&quot; , tags : %{ &quot;key&quot; =&gt; &quot;value&quot; } } , # Actions # https://docs.aws.amazon.com/AmazonS3/latest/dev/intro-lifecycle-rules.html#intro-lifecycle-rules-actions actions : %{ transition : %{ trigger : { :date , ~D[2020-03-26] } , # Date or days based storage : &quot;&quot; } , expiration : %{ trigger : { :days , 2 } , # Date or days based expired_object_delete_marker : true } , noncurrent_version_transition : %{ trigger : { :days , 2 } , # Only days based storage : &quot;&quot; } , noncurrent_version_expiration : %{ trigger : { :days , 2 } # Only days based } , abort_incomplete_multipart_upload : %{ trigger : { :days , 2 } # Only days based } } }","ref":"ExAws.S3.html#put_bucket_lifecycle/2","title":"ExAws.S3.put_bucket_lifecycle/2","type":"function"},{"doc":"Update or create a bucket logging configuration","ref":"ExAws.S3.html#put_bucket_logging/2","title":"ExAws.S3.put_bucket_logging/2","type":"function"},{"doc":"Update or create a bucket notification configuration","ref":"ExAws.S3.html#put_bucket_notification/2","title":"ExAws.S3.put_bucket_notification/2","type":"function"},{"doc":"Update or create a bucket policy configuration","ref":"ExAws.S3.html#put_bucket_policy/2","title":"ExAws.S3.put_bucket_policy/2","type":"function"},{"doc":"Update or create a bucket replication configuration","ref":"ExAws.S3.html#put_bucket_replication/2","title":"ExAws.S3.put_bucket_replication/2","type":"function"},{"doc":"Update or create a bucket requestPayment configuration","ref":"ExAws.S3.html#put_bucket_request_payment/2","title":"ExAws.S3.put_bucket_request_payment/2","type":"function"},{"doc":"Update or create a bucket tagging configuration","ref":"ExAws.S3.html#put_bucket_tagging/2","title":"ExAws.S3.put_bucket_tagging/2","type":"function"},{"doc":"Update or create a bucket versioning configuration Example ExAws.S3 . put_bucket_versioning ( &quot;my-bucket&quot; , &quot;&lt;VersioningConfiguration&gt;&lt;Status&gt;Enabled&lt;/Status&gt;&lt;/VersioningConfiguration&gt;&quot; ) |&gt; ExAws . request ( )","ref":"ExAws.S3.html#put_bucket_versioning/2","title":"ExAws.S3.put_bucket_versioning/2","type":"function"},{"doc":"Update or create a bucket website configuration","ref":"ExAws.S3.html#put_bucket_website/2","title":"ExAws.S3.put_bucket_website/2","type":"function"},{"doc":"Create an object within a bucket","ref":"ExAws.S3.html#put_object/4","title":"ExAws.S3.put_object/4","type":"function"},{"doc":"Create or update an object's access control policy","ref":"ExAws.S3.html#put_object_acl/3","title":"ExAws.S3.put_object_acl/3","type":"function"},{"doc":"Copy an object","ref":"ExAws.S3.html#put_object_copy/5","title":"ExAws.S3.put_object_copy/5","type":"function"},{"doc":"Add a set of tags to an existing object Options :version_id - The versionId of the object that the tag-set will be added to.","ref":"ExAws.S3.html#put_object_tagging/4","title":"ExAws.S3.put_object_tagging/4","type":"function"},{"doc":"Multipart upload to S3. Handles initialization, uploading parts concurrently, and multipart upload completion. Uploading a stream Streams that emit binaries may be uploaded directly to S3. Each binary will be uploaded as a chunk, so it must be at least 5 megabytes in size. The S3.Upload.stream_file helper takes care of reading the file in 5 megabyte chunks. &quot;path/to/big/file&quot; |&gt; S3.Upload . stream_file |&gt; S3 . upload ( &quot;my-bucket&quot; , &quot;path/on/s3&quot; ) |&gt; ExAws . request! #=&gt; :done Options These options are specific to this function See Task.async_stream/5 's :max_concurrency and :timeout options. :max_concurrency - only applies when uploading a stream. Sets the maximum number of tasks to run at the same time. Defaults to 4 :timeout - the maximum amount of time (in milliseconds) each task is allowed to execute for. Defaults to 30_000 . All other options (ex. :content_type ) are passed through to ExAws.S3.initiate_multipart_upload/3 .","ref":"ExAws.S3.html#upload/4","title":"ExAws.S3.upload/4","type":"function"},{"doc":"Upload a part for a multipart upload","ref":"ExAws.S3.html#upload_part/6","title":"ExAws.S3.upload_part/6","type":"function"},{"doc":"Upload a part for a multipart copy","ref":"ExAws.S3.html#upload_part_copy/5","title":"ExAws.S3.upload_part_copy/5","type":"function"},{"doc":"","ref":"ExAws.S3.html#t:acl_opt/0","title":"ExAws.S3.acl_opt/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:acl_opts/0","title":"ExAws.S3.acl_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:amz_meta_opts/0","title":"ExAws.S3.amz_meta_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:canned_acl/0","title":"ExAws.S3.canned_acl/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:customer_encryption_opts/0","title":"ExAws.S3.customer_encryption_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:delete_object_opt/0","title":"ExAws.S3.delete_object_opt/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:delete_object_opts/0","title":"ExAws.S3.delete_object_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:download_file_opts/0","title":"ExAws.S3.download_file_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:encryption_opts/0","title":"ExAws.S3.encryption_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:get_object_opts/0","title":"ExAws.S3.get_object_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:get_object_response_opts/0","title":"ExAws.S3.get_object_response_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:grant/0","title":"ExAws.S3.grant/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:grantee/0","title":"ExAws.S3.grantee/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:head_object_opt/0","title":"ExAws.S3.head_object_opt/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:head_object_opts/0","title":"ExAws.S3.head_object_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:initiate_multipart_upload_opt/0","title":"ExAws.S3.initiate_multipart_upload_opt/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:initiate_multipart_upload_opts/0","title":"ExAws.S3.initiate_multipart_upload_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:list_objects_opts/0","title":"ExAws.S3.list_objects_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:list_objects_v2_opts/0","title":"ExAws.S3.list_objects_v2_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:presigned_post_opts/0","title":"ExAws.S3.presigned_post_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:presigned_post_result/0","title":"ExAws.S3.presigned_post_result/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:presigned_url_opts/0","title":"ExAws.S3.presigned_url_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:put_object_copy_opts/0","title":"ExAws.S3.put_object_copy_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:put_object_opts/0","title":"ExAws.S3.put_object_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:upload_opt/0","title":"ExAws.S3.upload_opt/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:upload_opts/0","title":"ExAws.S3.upload_opts/0","type":"type"},{"doc":"","ref":"ExAws.S3.html#t:upload_part_copy_opts/0","title":"ExAws.S3.upload_part_copy_opts/0","type":"type"},{"doc":"Represents an AWS S3 file download operation","ref":"ExAws.S3.Download.html","title":"ExAws.S3.Download","type":"module"},{"doc":"","ref":"ExAws.S3.Download.html#build_chunk_stream/2","title":"ExAws.S3.Download.build_chunk_stream/2","type":"function"},{"doc":"","ref":"ExAws.S3.Download.html#chunk_stream/2","title":"ExAws.S3.Download.chunk_stream/2","type":"function"},{"doc":"","ref":"ExAws.S3.Download.html#get_chunk/3","title":"ExAws.S3.Download.get_chunk/3","type":"function"},{"doc":"","ref":"ExAws.S3.Download.html#t:t/0","title":"ExAws.S3.Download.t/0","type":"type"},{"doc":"","ref":"ExAws.S3.Parsers.html","title":"ExAws.S3.Parsers","type":"module"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_all_my_buckets_result/1","title":"ExAws.S3.Parsers.parse_all_my_buckets_result/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_bucket_object_versions/1","title":"ExAws.S3.Parsers.parse_bucket_object_versions/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_complete_multipart_upload/1","title":"ExAws.S3.Parsers.parse_complete_multipart_upload/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_initiate_multipart_upload/1","title":"ExAws.S3.Parsers.parse_initiate_multipart_upload/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_list_multipart_uploads/1","title":"ExAws.S3.Parsers.parse_list_multipart_uploads/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_list_objects/1","title":"ExAws.S3.Parsers.parse_list_objects/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_list_parts/1","title":"ExAws.S3.Parsers.parse_list_parts/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_object_tagging/1","title":"ExAws.S3.Parsers.parse_object_tagging/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_upload/1","title":"ExAws.S3.Parsers.parse_upload/1","type":"function"},{"doc":"","ref":"ExAws.S3.Parsers.html#parse_upload_part_copy/1","title":"ExAws.S3.Parsers.parse_upload_part_copy/1","type":"function"},{"doc":"Represents an AWS S3 Multipart Upload operation. Implements ExAws.Operation.perform/2 Examples &quot;path/to/big/file&quot; |&gt; S3.Upload . stream_file |&gt; S3 . upload ( &quot;my-bucket&quot; , &quot;path/on/s3&quot; ) |&gt; ExAws . request! #=&gt; :done See ExAws.S3.upload/4 for options","ref":"ExAws.S3.Upload.html","title":"ExAws.S3.Upload","type":"module"},{"doc":"","ref":"ExAws.S3.Upload.html#complete/3","title":"ExAws.S3.Upload.complete/3","type":"function"},{"doc":"","ref":"ExAws.S3.Upload.html#initialize/2","title":"ExAws.S3.Upload.initialize/2","type":"function"},{"doc":"Open a file stream for use in an upload. Chunk size must be at least 5 MiB. Defaults to 5 MiB","ref":"ExAws.S3.Upload.html#stream_file/2","title":"ExAws.S3.Upload.stream_file/2","type":"function"},{"doc":"","ref":"ExAws.S3.Upload.html#upload_chunk/3","title":"ExAws.S3.Upload.upload_chunk/3","type":"function"},{"doc":"Upload a chunk for an operation. The first argument is a tuple with the binary contents of the chunk, and a positive integer index indicating which chunk it is. It will return this index along with the etag response from AWS necessary to complete the multipart upload.","ref":"ExAws.S3.Upload.html#upload_chunk!/3","title":"ExAws.S3.Upload.upload_chunk!/3","type":"function"},{"doc":"","ref":"ExAws.S3.Upload.html#t:t/0","title":"ExAws.S3.Upload.t/0","type":"type"}]